/*
 *
 * Copyright (c) 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Hourglass.
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation is hereby granted without fee, provided that the
 * above copyright notice and this permission/disclaimer notice is
 * retained in all copies or modified versions, and that both notices
 * appear in supporting documentation.  THE COPYRIGHT HOLDERS PROVIDE
 * THIS SOFTWARE "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE COPYRIGHT
 * HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 * RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu
 * any improvements that they make and grant redistribution rights to the
 * University of Utah.
 * 
 * Author: John Regehr (regehr@cs.utah.edu)
 */

#include "hourglass.h"

int num_threads;
int _DBG_LEVEL_ = 0;

int generate_gap_hist;

static void usage (void)
{
  fprintf (stderr, "usage: busy duration\n");
  exit (-1);
}

double TSC_MHZ = 0;

int main (int argc, char *argv[])
{
  int dur;
  double stop;

  if (argc != 2) usage ();
  if ((dur = atoi (argv[1])) < 1) {
    usage ();
  }

  TSC_MHZ = find_mhz ();
  printf ("running on a %.1f MHz machine\n", TSC_MHZ);

  printf ("about to busy-wait for %d seconds\n", dur);

  fflush (stdout);

  stop = dur + cycle_to_sec (rdtsc());

  set_priority (MAIN_PRI);

  do { } while (cycle_to_sec(rdtsc()) < stop);

  return 0;
}
