#include <hourglass.h>
#include <sched.h>
#include <signal.h>

#include <hls.h>
#include <rsv.h>

#define MAX_SETS 100

void make_res (us_time amount, 
	       us_time period,
	       int soft,
	       int which)
{
  struct sched_param param;
  int res;
  struct hls_param hls_p;
  struct CPU_RESERVATION rsv;

  rsv.BeginRes = 0;
  rsv.Soft = 0;
  rsv.Amount = 10*amount;  // HLS times are in 100ns units
  rsv.Period = 10*period;

  printf ("amount = %lld, period = %lld\n", rsv.Amount, rsv.Period);
    
  /*    hls_p.command = HLS_CMD_NULL_MSG;*/
  hls_p.command = 0;
  hls_p.sched_data = &rsv;
  hls_p.sched_data_size = sizeof(struct CPU_RESERVATION);
  hls_p.scheduler = "res1";
  hls_p.signature = HLS_SIGNATURE;
    
  param.sched_size = sizeof(struct hls_param);
  param.sched_p = &hls_p;

  res = sched_setscheduler(getpid(), SCHED_HLS, &param);
  if (res < 0) {
    perror("Cannot begin reservation!");
    exit(-1);
  }
}

void delete_res (int which)
{
  // FIXME -- nop for now
}
