/*
 *
 * Copyright (c) 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Hourglass.
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation is hereby granted without fee, provided that the
 * above copyright notice and this permission/disclaimer notice is
 * retained in all copies or modified versions, and that both notices
 * appear in supporting documentation.  THE COPYRIGHT HOLDERS PROVIDE
 * THIS SOFTWARE "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE COPYRIGHT
 * HOLDERS DISCLAIM ANY LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER
 * RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu
 * any improvements that they make and grant redistribution rights to the
 * University of Utah.
 * 
 * Author: John Regehr (regehr@cs.utah.edu)
 */

#include "hourglass.h"

/*
 * timers based on native Unix timers -- limited to 10ms resolution, usually
 */

static void unix_timed_sleep (int id, us_time t)
{
  unsigned long sleep_time = (unsigned long)(-t);
  assert (sleep_time >= 0);
  // printf ("about to sleep for %ld\n", sleep_time);
  usleep (sleep_time);
}

static void unix_init_timers (void)
{
}

static void unix_deinit_timers (void)
{
}

const struct timer_funcs unix_timer_funcs = {
  unix_timed_sleep,
  unix_init_timers,
  unix_deinit_timers
};
